require "docker/registry/api/version"

require 'json'
require 'rest-client'

AUTHORIZATION_TOKEN = 'YWxiaW46dDBpaVZ7NjFJbn4oKjU+QzlxO0wzQWMzRg=='
AUTHORIZATION_HEADERS = {Authorization: "Basic #{AUTHORIZATION_TOKEN}"}

module Docker
  module Registry
    module Api

      class DockerRegistryApi
        attr_accessor :base_url
        attr_accessor :certificate

        def initialize(base_url, certificate)
          @base_url = base_url
          @certificate = certificate
        end

        def execute_rest_request(method, endpoint)
          JSON.parse(RestClient::Request.execute(method: method, url: "#{@base_url}/#{endpoint}", ssl_ca_file: @certificate, headers: AUTHORIZATION_HEADERS), symbolize_names: true)
        end

        def get(endpoint)
          execute_rest_request(:get, endpoint)
        end

        def get_tag_list(repository)
          get("#{repository}/tags/list")
        end

        def list_repositories
          get("_catalog")
        end
      end

    end
  end
end
